﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;

namespace XamDataChartGroupBy
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Infragistics.GroupBy gb = new Infragistics.GroupBy();
            gb.ItemsSource = new TestEmissionsCollection();
            gb.GroupMemberPath = "Date";
            gb.KeyMemberPath = "Installation";
            gb.ValueMemberPath = "Emission";

            NumericXAxis xAxis = new NumericXAxis();
            xAxis.Label = "{:N2} EUR";
            this.theChart.Axes.Add(xAxis);

            CategoryYAxis yAxis = new CategoryYAxis();
            yAxis.ItemsSource = gb;
            yAxis.Label = "{Key}";
            this.theChart.Axes.Add(yAxis);

            StackedBarSeries series2 = new StackedBarSeries();
            series2.SeriesCreated += new StackedSeriesCreatedEventHandler(series2_SeriesCreated);
            series2.Legend = this.xmLegend;
            series2.ItemsSource = gb;
            series2.XAxis = xAxis;
            series2.YAxis = yAxis;
            series2.AutoGenerateSeries = true;
            this.theChart.Series.Add(series2);

        }

        void series2_SeriesCreated(object sender, StackedSeriesCreatedEventArgs e)
        {
            StackedFragmentSeries series = (StackedFragmentSeries)sender;

            if (series != null)
            {
                series.Title = series.ValueMemberPath.Replace("_Emission", string.Empty); ;
            }
        }
    }

    public class TestEmissionsCollection : ObservableCollection<InstalationEmissionDateInformation>
    {
        public TestEmissionsCollection()
        {
            Add(new InstalationEmissionDateInformation("A", 5, "1/1/2012", 1));
            Add(new InstalationEmissionDateInformation("B", 2, "1/1/2012", 1));
            Add(new InstalationEmissionDateInformation("C", 7, "1/1/2012", 1));
            Add(new InstalationEmissionDateInformation("A", 6, "1/2/2012", 1));
            Add(new InstalationEmissionDateInformation("B", 3, "1/2/2012", 1));
            Add(new InstalationEmissionDateInformation("C", 8, "1/2/2012", 1));
            Add(new InstalationEmissionDateInformation("A", 6, "1/3/2012", 1));
            Add(new InstalationEmissionDateInformation("B", 3, "1/3/2012", 1));
            Add(new InstalationEmissionDateInformation("C", 6, "1/3/2012", 1));
            Add(new InstalationEmissionDateInformation("A", 4, "1/4/2012", 1));
            Add(new InstalationEmissionDateInformation("B", 3, "1/4/2012", 1));
            Add(new InstalationEmissionDateInformation("C", 7, "1/4/2012", 1));
        }
    }

    public class InstalationEmissionDateInformation
    {
        public string Installation { get; set; }
        public Decimal Emission { get; set; }
        public string Date { get; set; }
        public Decimal Assignation { get; set; }

        public InstalationEmissionDateInformation(string installation, Decimal emission, string date, Decimal assignation)
        {
            Installation = installation;
            Emission = emission;
            Date = date;
            Assignation = assignation;
        }
    }  

}
